﻿var isEnd
, five_num_left
, ten_num_left
, empty_num_left
, five_num
, ten_num
, empty_num
, zad_num
, score
, time
, body
, clock
, canvas
, context
, canvasWidth
, canvasHeight;
function catchRedPacket(dom){
	canvas = document.querySelector(dom);
	context = canvas.getContext('2d');
	canvasWidth = canvas.getAttribute('width');
	canvasHeight = canvas.getAttribute('height');
	if(isEnd === false) {
		return ;
	}
	// 初始化页面数据
	init();
	body = new Body();
	// 加载倒计时
	timedCount();
	// 加载动画
	window.requestNextAnimationFrame(animate);
}

// 页面倒计时
function timedCount() {
	document.querySelector("#clock").innerHTML = time + "秒";
	if(time <= 0) {
		clearTimeout(clock);
		isEnd = true;
		amount=five_num+ten_num*2+empty_num+zad_num*-2;
		//alert('结束了,一共抢到'+amount+'元');
		 fnhbsave(amount);
	} else {
		time = time - 1;
		clock = setTimeout("timedCount()", 1000);
	}
}

//初始化
function init() {
	isEnd = false; //游戏结束
	five_num_left = 0;
	ten_num_left = 0;
	empty_num_left = 0;
	five_num = 0;
	ten_num = 0;
	empty_num = 0;
	zad_num = 0
	score = 0;
	time = 10;
	amount = 0;
	clock = '';
}
function animate(now) {
	body.clear();
	body.draw();
	if(!isEnd) {
		requestNextAnimationFrame(animate);
	}
}
(function() {
	var five = new Image(); //5
	five.src = "../../res/img/f1.png";
	var ten = new Image(); //100
	ten.src = "../../res/img/f2.png";
	var empty = new Image(); //空的
	empty.src = "../../res/img/f3.png";
	var zad = new Image(); //炸弹
	zad.src = "../../res/img/f0.png";
	var moneyEnum = {
		five: {
			image: five,
			speed: 10,
			value: 1,
			widths: 32,
			heights: 36,
		},
		ten: {
			image: ten,
			speed: 12,
			value: 2,
			widths: 32,
			heights: 36
		},
		empty: {
			image: empty,
			speed: 14,
			value: 1,
			widths: 32,
			heights: 36,
		},
		zad: {
			image: zad,
			speed: 8,
			value: -2,
			widths: 41,
			heights: 36,
		}
	};

	var money = function(x, type) {
		this.x = x;
		this.y = 0;
		this.type = type;
		this.status = 0; //0正在掉落，1接住 ，2没接住
		this.widths = moneyEnum[this.type].widths;
		this.heights = moneyEnum[this.type].heights;

	}

	money.prototype.draw = function() {
		if(this.status == 0) {
			context.drawImage(moneyEnum[this.type].image, this.x, this.y, moneyEnum[this.type].widths, moneyEnum[this.type].heights);
		}
	}

	money.prototype.drop = function() {
		//速度叠加
		this.y += moneyEnum[this.type].speed;

		if(this.status == 0 && body.mainpen.y > this.y && body.mainpen.y < this.y + this.heights && body.mainpen.x > this.x && body.mainpen.x < this.x + this.widths) { //

			this.status = 1;

			score += moneyEnum[this.type].value; //记录总分数

			if(moneyEnum[this.type].image == five) {
				five_num += 1;

			} else if(moneyEnum[this.type].image == ten) {
				//console.log('100元红包');
				ten_num += 1;
				time += 1;

			} else if(moneyEnum[this.type].image == empty) {
				//console.log('没有点中');
				empty_num += 1;
			} else if(moneyEnum[this.type].image == zad) { //炸弹
				//console.log('炸弹');
				zad_num += 1;
				time -= 1;
			}

		} else if(this.y >= 1039) {
			this.status = 2;
		}
		this.draw();
	}

	window.money = money;
	window.pen = function() {};

	var Body = function() {
		var that = this;
		this.moneyList = [];
		this.mainpen = new pen();

		document.addEventListener('touchstart', touch, false);
		document.addEventListener('touchend', touch, false);
		var touchx;
		var touchy;

		function touch(event) { //点击 
			var event = event || window.event;
			switch(event.type) {
				case "touchstart":
					that.mainpen.x = event.touches[0].clientX;
					that.mainpen.y = event.touches[0].clientY;
					break;

				case "touchend":
					that.mainpen.x = 0;
					that.mainpen.y = 0;
					break;
			}
		}

		var addInterval = setInterval(function() {
			if(!isEnd) {
				that.addMoney(Math.random() * 470 + 50);
			} else {
				clearInterval(addInterval);
			}
		}, 500);
	}

	//开始
	Body.prototype.start = function() {

	}

	//清屏
	Body.prototype.clear = function() {
		context.clearRect(0, 0, canvasWidth, canvasHeight);
	}

	//掉钱
	Body.prototype.addMoney = function(x) {
		var random = Math.floor(Math.random() * 4);
		if(random == 0 && five_num_left >= 0 && !isEnd) {
			this.moneyList.push(new money(x, "five"));
		} else if(random == 1 && ten_num_left >= 0 && !isEnd) {
			this.moneyList.push(new money(x, "ten"));
		} else if(random == 2 && empty_num_left >= 0 && !isEnd) {
			this.moneyList.push(new money(x, "empty"));
		} else if(random == 3 && empty_num_left >= 0 && !isEnd) {
			this.moneyList.push(new money(x, "zad"));
		}
	}

	Body.prototype.draw = function() {
		this.moneyList.forEach(function(item) {
			item.drop();
		});

		//context.font = "24px 微软雅黑";
		//context.fillStyle = "red";
		//context.fillText("score:" + score, 10, 50);
		//context.fillText("5元× " + five_num, 30, 918);
		//context.fillText("10元× " + ten_num, 180, 918);
		//context.fillText("空× " + empty_num, 350, 918);
		//context.fillText("炸弹× " + zad_num, 500, 918);

	}
	window.Body = Body;
})();


window.requestNextAnimationFrame =
   (function () {
      var originalWebkitRequestAnimationFrame = undefined,
          wrapper = undefined,
          callback = undefined,
          geckoVersion = 0,
          userAgent = navigator.userAgent,
          index = 0,
          self = this;

      // Workaround for Chrome 10 bug where Chrome
      // does not pass the time to the animation function
      
      if (window.webkitRequestAnimationFrame) {
         // Define the wrapper

         wrapper = function (time) {
           if (time === undefined) {
               time = +new Date();
           }
           self.callback(time);
         };

         // Make the switch
          
         originalWebkitRequestAnimationFrame = window.webkitRequestAnimationFrame;    

         window.webkitRequestAnimationFrame = function (callback, element) {
            self.callback = callback;

            // Browser calls the wrapper and wrapper calls the callback
            
            originalWebkitRequestAnimationFrame(wrapper, element);
         }
      }

      // Workaround for Gecko 2.0, which has a bug in
      // mozRequestAnimationFrame() that restricts animations
      // to 30-40 fps.

      if (window.mozRequestAnimationFrame) {
         // Check the Gecko version. Gecko is used by browsers
         // other than Firefox. Gecko 2.0 corresponds to
         // Firefox 4.0.
         
         index = userAgent.indexOf('rv:');

         if (userAgent.indexOf('Gecko') != -1) {
            geckoVersion = userAgent.substr(index + 3, 3);

            if (geckoVersion === '2.0') {
               // Forces the return statement to fall through
               // to the setTimeout() function.

               window.mozRequestAnimationFrame = undefined;
            }
         }
      }
      
      return window.requestAnimationFrame   ||
         window.webkitRequestAnimationFrame ||
         window.mozRequestAnimationFrame    ||
         window.oRequestAnimationFrame      ||
         window.msRequestAnimationFrame     ||

         function (callback, element) {
            var start,
                finish;

            window.setTimeout( function () {
                start = +new Date();
               callback(start);
               finish = +new Date();

               self.timeout = 1000 / 60 - (finish - start);

            }, self.timeout);
         };
      }
   )
();
